#ifndef BILLYSHEET_HABILETE_HPP
#define BILLYSHEET_HABILETE_HPP

#include <cstdint>
#include "characteristic.hpp"

namespace character::characteristic {
    class Habilete final : public Characteristic {
    public:
        Habilete() noexcept: Characteristic(2, 0, 0, 0) {};

        Habilete(const uint32_t carac, const uint32_t materiel, const uint32_t additional) noexcept:
                Characteristic(2, carac, materiel, additional) {}

        ~Habilete() noexcept final = default;

        friend void from_json(const json &j, Habilete &habilete) {
            nlohmann::from_json(j, static_cast<Characteristic &>(habilete));
        }
    };

    static void to_json(json &j, const Habilete &habilete) {
        to_json(j, static_cast<Characteristic>(habilete));
    }
}


#endif //BILLYSHEET_HABILETE_HPP
